config/routes.rb
Rails.application.routes.draw do
  resources :notes
  get 'statistics/show'
  get 'pages/no_project'
  get 'calendar/show'
  get 'pages/home'

  devise_for :users

  resources :projects do
    resources :tasks do
      resources :allocated_times do
        member do
          post :complete
          post :ignore
        end
      end

      member do
        post :complete
        post :uncomplete
      end
    end
  end

  root to: 'pages#home'
end

app/models/allocated_time.rb
class AllocatedTime < ApplicationRecord
  belongs_to :task
  belongs_to :user
  default_scope -> { order(start: :asc) }
  #scope :done, -> () { where(done: true) }
  #scope :ignored, -> () { where(ignored: true) }
  validates :user_id, presence: true
  validates :task_id, presence: true
  validates :start, presence: true
  validates_datetime :end, after: :start, after_message: 'end must be after start'#, on_or_before: task.deadline, on_or_before_message: 'end must be on or before deadline'}

  def start_time
    self.start
  end

  def end_time
    self.end
  end

end

app/controllers/allocated_times_controller.rb
class AllocatedTimesController < ApplicationController
  load_and_authorize_resource
  before_action :set_atime, only: [:edit, :update, :destroy]
  before_action :set_task_project

  def new
    @allocated_time = AllocatedTime.new
  end

  def edit
  end

  def complete
    if @allocated_time.update_attributes(done: true, ignored: false)
      flash[:success] = 'Allocated time completed'
    end
    redirect_to @project
  end

  def ignore
    if @allocated_time.update_attributes(done: false, ignored: true)
      flash[:success] = 'Allocated time set as ignored'
    end
    redirect_to @project
  end

  def update
    if @allocated_time.update(allocated_time_params)
      flash[:success] = 'Time edited'
      redirect_to @project
    else
      render 'edit'
    end
  end

  def create
    @allocated_time = @task.allocated_times.create(allocated_time_params)
    if @allocated_time.done
      @allocated_time.ignored = false
    end
    @allocated_time.user_id = current_user.id
    if @allocated_time.save
      flash[:success] = "Time allocated"
      redirect_to @project
    else
      flash[:danger] = 'Time not allocated'
      render 'new'
    end
  end

  def destroy
    @allocated_time.destroy
    flash[:success] = "Time deleted"
    redirect_to @project
  end

  private
    def set_atime
      @allocated_time = AllocatedTime.find(params[:id])
    end

    def set_task_project
      @task = Task.find(params[:task_id])
      @project = Project.find_by(id: @task.project_id)
    end


    def allocated_time_params
      params.require(:allocated_time).permit(:project, :task, :user, :done, :start, :end)
    end
end

app/helpers/allocated_times_helper.rb
module AllocatedTimesHelper
end

app/views/allocated_times/_allocated_time.html.slim
tr
  th class="al_time_status" id="al_time_d_#{allocated_time.done}_i_#{allocated_time.ignored}"
    -if allocated_time.done
      ="Done"
    - elsif allocated_time.ignored
      ="Ignored"
  th id="time-time"
    =allocated_time.start.strftime("%d. %b %Y   %H:%M \u2013 ")
    =allocated_time.end.strftime(" %d. %b %Y  %H:%M")
  th
    =link_to "I did it!", complete_project_task_allocated_time_path(@project, task, allocated_time), method: :post, class: "btn btn-success btn-sm"
    =link_to "I did not!", ignore_project_task_allocated_time_path(@project, task, allocated_time), method: :post, class: "btn btn-danger btn-sm"
    =link_to "Edit", edit_project_task_allocated_time_path(@project, task, allocated_time), class: "btn btn-info btn-sm"
    =link_to "Delete", project_task_allocated_time_path(@project, task, allocated_time), method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-warning btn-sm'

app/views/allocated_times/_form.html.slim
=simple_form_for allocated_time, url: polymorphic_path([:project, :task, allocated_time]) do |f|
  div class="form-inputs"
    =f.input :start, required: true, autofocus: true
    =f.input :end, required: true
    =f.input :done, label:"Already Done"
  div class="form-actions"
    =f.button :submit, "Allocate Time"

app/views/allocated_times/edit.html.slim
h1 Edit Allocated Time
=render 'allocated_times/form', allocated_time: @allocated_time
=link_to 'Back', :back

app/views/allocated_times/new.html.slim
h1 Allocate Time
=render 'allocated_times/form', allocated_time: @allocated_time
=link_to 'Back', :back